#include "bits/stdc++.h"

using namespace std;

const long long LIMIT = 1'000'000'060'000'000'000LL;

bool czy_jest_kwadratem(long long X) {
  long long pierwiastek = floor(sqrtl(X));
  return pierwiastek * pierwiastek == X;
}

// Liczby potęgowe podzielimy na:
// małe liczby potęgowe (z wykładnikiem równym 2),
// duże liczby potęgowe (z wykładnikiem większym niż 2).

vector<long long> duze_potegowe;

// Generujemy duże liczby potegowe (z wykładnikiem większym niż 2).
void wygeneruj_duze_potegowe() {
  set<long long> potegowe;
  long long baza = 2;
  while (true) {
    long long aktualna_potega = baza * baza * baza;
    if (aktualna_potega > LIMIT)
      break;
    while (aktualna_potega <= LIMIT) {
      // Chcemy mieć jedynie duże liczby potęgowe, więc
      // sprawdzamy czy przez przypadek nie jest kwadratem
      // (tj. małą liczbą potęgową).
      if (!czy_jest_kwadratem(aktualna_potega)) {
        potegowe.insert(aktualna_potega);
      }
      if (LIMIT / baza < aktualna_potega)
        break; // Unikamy przekroczenia zakresu long long.
      aktualna_potega *= baza;
    }
    baza++;
  }
  duze_potegowe = vector<long long>(potegowe.begin(), potegowe.end());
}

// Liczymy ile jest małych liczb potęgowych mniejszych od X.
long long ile_mniejszych_malych(long long X) { return floor(sqrtl(X - 1)) - 1; }

// Zwraca którą liczbą potęgową jest X.
long long ktora_potegowa(long long X) {
  long long mniejszych_malych = ile_mniejszych_malych(X);
  long long mniejszych_duzych =
      lower_bound(duze_potegowe.begin(), duze_potegowe.end(), X) -
      duze_potegowe.begin();
  return X - mniejszych_malych - mniejszych_duzych;
}

// Używamy wyszukiwania binarnego do znalezienia odpowiedzi.
long long wyszukiwanie_binarne(long long N) {
  long long a = 1, b = LIMIT;
  while (b - a > 1) {
    long long mid = (a + b) / 2;
    // Pytamy, którą liczbą niepotęgową jest mid.
    if (ktora_potegowa(mid) <= N) {
      a = mid;
    } else {
      b = mid;
    }
  }
  return a;
}

int main() {
  wygeneruj_duze_potegowe();

  int T;
  cin >> T;
  while (T--) {
    long long N;
    cin >> N;
    cout << wyszukiwanie_binarne(N) << "\n";
  }

  return 0;
}
